#!/usr/bin/bash
# ----------------------------------------------------------------------
# detect ttyplayer in markdown files
# ----------------------------------------------------------------------

# ----------------------------------------------------------------------
# CONFIG
# ----------------------------------------------------------------------
cd "$(dirname "$0")/../docs" || exit 1

ttysource=/home/axel/sources/docker/docpages/public_html/docs/addons/ttyrec

ttyblock="<!-- START-ADD-TTY-PLAYER -->
<html>
    <script src=ttyrec/webcomponents-lite.min.js></script>
    <link rel=stylesheet href=ttyrec/tty-player.css>
    <script src=ttyrec/term.min.js></script>
    <script src=ttyrec/tty-player.min.js></script>
</html>
<!-- END-ADD-TTY-PLAYER -->"

# ----------------------------------------------------------------------
# MAIN
# ----------------------------------------------------------------------
echo
echo "Detect ttyplayer in markdown files..."
echo

for myfile in $( grep -rl "<tty-player" *md )
do
    echo "--- $myfile"
    if grep -q "$ttyblock" "$myfile"; then
        echo "SKIP: html header found."
    else
        echo "Adding html header..."
        ( echo "$ttyblock" ; echo; cat "$myfile" ) >> "$myfile.tmp"
        mv "$myfile.tmp" "$myfile"
    fi

    # if the 1st player was found: add ttyrec as softlink below docs folder
    ls -ld ttyrec 2>/dev/null | grep -q "^l" || ln -s "$ttysource"
done

echo "Done"
# ----------------------------------------------------------------------
